"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _uriResolver = _interopRequireDefault(require("./uri-resolver"));

var _graphRdfaProcessor = _interopRequireDefault(require("./graph-rdfa-processor"));

var _rdfaGraph = require("./rdfa-graph");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(document) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var node = document.documentElement || document;
  var baseURI = options.baseURI ? options.baseURI : node.baseURI;
  var graph = new _rdfaGraph.RDFaGraph();
  var target = {
    graph: graph,
    baseURI: new _uriResolver.default().parseURI(baseURI)
  };
  var processor = new _graphRdfaProcessor.default(target);
  processor.process(node, options);
  return target.graph;
}

;
module.exports = exports.default;